SetBatchLines, -1
#SingleInstance, Force

#Include %A_ScriptDir%\pArr.ahk

Global WholeCalendar
GLOBAL cWB
GLOBAL mD
global MDO

mDO := []
Events := []

Events := 	 [{"start":"1","length":"9","desc":"7 DAY VACATIOOOONN!!"}, {"start":"1","length":"3","desc":"C1 Event2"}, {"start":"1","length":"1","desc":"C1 Event3"}
			, {"start":"2","length":"8","desc":"C2 Event1"}, {"start":"2","length":"1","desc":"C2 Event2"}
			, {"start":"3","length":"2","desc":"C3 Event1"}, {"start":"3","length":"2","desc":"C3 Event2"}	
			, {"start":"4","length":"1","desc":"C4 Event1"}
			, {"start":"5","length":"1","desc":"C5 Event1"}
			, {"start":"6","length":"3","desc":"C6 Event1"}, {"start":"6","length":"3","desc":"C6 Event1"}
			, {"start":"7","length":"1","desc":"C7 Event1"}
			, {"start":"7","length":"1","desc":"C7 Event2"}]


Gui,+Resize
Gui,Add,ActiveX,w600 h600 vcWB,Shell.Explorer
Gui,Show,Maximize
;Gui,Maximize

fileread,html, % A_ScriptDir "\MainCalendar.html"
fileread,css, % A_ScriptDir "\CalendarStyle.css"
Display(cWB, html)
while (cWB.readyState != 4)
	sleep, 10

Style := cWB.document.createElement("Style")
style.appendChild(cWB.document.createTextNode(css))
Head := cWB.document.getElementsByTagName("head")[0]
Head.appendChild(style)

getMonthDays(A_YYYY,A_MM)
buildView()
attachEvents()

InsertEvents(Events)

return

guisize:
guicontrol,move,cWB, % "w" A_GuiWidth-10 " h" A_Guiheight-10
return

ESC::
Exitapp

FindOpenSpaces(week){
	Loop
	{
		if(A_Index=3)
			b=b
		result := cWB.document.getElementsByClassName("table-Row")[week].querySelectorAll(".columnContainer div:nth-child(" A_Index ")")
		row :=
		if(result.length > 0)
		{
			B_Index = 0
			loop
			{
				Loop2 := A_Index
				try
				{
					EventType := result[A_Index-1].className
					EventCol := SubStr(StrSplit(result[A_Index-1].parentNode.className," ").2,2,1)
				}catch{
					EventType := ""
					EventCol := ""
				}
				
				If(EventType = "")
				{
					row .= "0"
					B_Index += 1
				}else if(Loop2 < EventCol){
					While((B_Index) < EventCol - 1)
					{
						row .= "0"
						B_Index += 1	
					} 
					loop % SubStr(StrSplit(EventType," ").2,2,1)
					{
						If(A_Index = 1)
							row .= "X"
						else
							row .= "P"
						B_Index += 1
					}
				}else{
					loop % SubStr(StrSplit(EventType," ").2,2,1)
					{
						If(A_Index = 1)
							row .= "X"
						else
							row .= "P"
						B_Index += 1
					}
				}
			} until B_Index >= 7
		}else{
			row := "0000000"
		}
		a .= row "`n"
	}until result.length=0	
	return, a	
}

DayOfWeek(DateString)
{
	formattime,DayInWeek,%DateString%,Wday
	return, DayInWeek
}

DaysInMonthYear(Month,Year)
{
	return, [31,28 + (!Mod(Year,400) || (!Mod(Year,4) && Mod(Year,100))),31,30,31,30,31,31,30,31,30,31][ Month ]
}

buildView()
{
	setformat, Float, 0.0
	Months := ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]
	
	Month := mDO.Month
	NextMonth := mDO.NextMonth
	Current := mDO.NumOfDays
	Previous := mDO.PriorMonthDays
	Next := mDO.NextMonthDays
	Start := mDO.Start
	
	Index = 0
	Row = 0
	Next := 42 - Current - (Start - 1)
	Prev := Start - 1
	While(Index < 42)
	{		
		CellValue := (Index < Prev) ? Previous - (start - 2) + index
				:  (Index <= Current+(Start-2)) ? Index - start + 2
				:  (Index - Current-(Start-2))
		
		cColor := (Index < Prev) ? "rgb(150, 146, 146)"
				:  (Index <= Current+(Start-2)) ? "rgb(69, 69, 69)"
				:  "rgb(150, 146, 146)"
		
		cMonth := (Index < Prev) ? mDO.PriorMonth
				:  (Index <= Current+(Start-2)) ? mDO.Month
				:  mDO.NextMonth
		
		cYear := (Index < Prev) ? mDO.PriorYear
				:  (Index <= Current+(Start-2)) ? mDO.Year
				:  mDO.NextYear
		
		cText := (CellValue = 1 && Index < Current) ? (CellValue " - " Months[Month]) 
					: (CellValue = 1 && Index > Current) ? CellValue " - " Months[NextMonth]
					: CellValue
		
		Row := Mod(Index,7) = 0 ? Row+=1 : Row
		
		If(Mod(A_Index,7)=0)
			CellRow := cWB.document.querySelectorAll(".divRowTable-Container")[(A_Index/7)-1]
		Cell := cWB.document.querySelectorAll(".table-Row th a")[A_Index-1]
		Cell.innerText := cText
		
		Cell.setAttribute("id",cMonth cellValue cYear)
		Index++
	}
	cWB.document.parentWindow.ahk_CellClick := Func("CellClick")
}

Next()
{
	mDO.Month++
	mDO.Month := mDO.Month > 12 ? 1 : mDO.Month
	mDO.Year := mDO.Month > 12 ? mDO.Year++ : mDO.Year
	getMonthDays(mDO.Year,mDO.Month)
	BuildView()
}
Prev()
{
	mDO.Month--
	mDO.Month := mDO.Month < 1 ? 12 : mDO.Month
	mDO.Year := mDO.Month < 1 ? mDO.Year-- : mDO.Year
	getMonthDays(mDO.Year,mDO.Month)
	BuildView()
}

InsertEvents(Events)
{
	For Each, Event in Events
	{
		eventDesc := Event.desc
		eventStart := Event.Start - 1
		eventLength := Event.Length
		StartWeek = 0
		
		slot :=
		pCount = 0
		Loop % EventLength
			Slot .= "0"

		newLen := eventLength
		Loop
		{
			If(eventlength + eventStart > 7)
			{
				Slot := SubStr(Slot,1,7 - eventStart)
				newLen := eventLength - StrLen(Slot)
			}else{
				Slot := 
				Loop % newLen
					Slot .= "0"
			}
			
			startColumn := cWB.document.getElementsByClassName("table-Row")[StartWeek].getElementsByClassName("columnContainer")[eventStart]
			Open := FindOpenSpaces(StartWeek)
			Loop,Parse,Open,"`n"
			{
				OpenSpot := SubStr(A_LoopField,eventStart+1,StrLen(Slot))
				if(OpenSpot = Slot)
				{
					Loop % pCount
						if (cWB.document.getElementsByClassName("table-Row")[StartWeek].getElementsByClassName("columnContainer")[eventStart].querySelectorAll("div").length < pCount+1)
							PlaceHolder(eventStart,StartWeek)
					AddEvent(StrLen(Slot),eventDesc,startColumn)
					break
				}else if(substr(OpenSpot,1,1) = "P"){
					pCount+=1
				}
			}
			pCount :=
			eventStart = 0
			eventLength -= StrLen(Slot)
			StartWeek += 1
		} until eventLength = 0
	}
}

CellClick(event,this)
{
	Container := cWB.document.querySelector("#Calendar tbody").getBoundingClientRect()
	ContainerHeight := Container.Bottom - Container.top
	ContainerWidth := Container.right - Container.left
	
	CellWidths := ContainerWidth/7
	CellHeights := ContainerHeight/6
	
	OriginalWidth := CellWidths
	OriginalHeight := CellHeights
	clickPosX := event.clientX
	clickPosY := event.clientY - Container.top
	
	loop {
		Column := A_Index - 1
		if(clickPosX <= originalWidth)
			break
		OriginalWidth += CellWidths
	} 
	
	loop {
		Row := A_Index - 1
		if(clickPosY <= originalHeight)
			break
		OriginalHeight += CellHeights
	} 
	
	Element := cWB.document.querySelectorAll(".divRowTable-Container")[Row].getElementsByTagName("tbody")[0]
	CurrentRows := cWB.document.querySelectorAll(".divRowTable-Container")[Row].getElementsByTagName("tbody")[0].getElementsByTagName("tr")
	CurrentColumns := cWB.document.querySelectorAll(".divRowTable-Container")[Row].getElementsByTagName("tbody")[0].getElementsByTagName("td")
	
	cWB.document.parentWindow.EventClicked := Func("EventClicked()")
	clipboard := cWB.document.body.innerHTML
}

ahk_eventClicked(e,this)
{
	msgbox % this.innerHTML
	e.stopPropagation()
}

getMonthDays(Y,M)
{	
	mDO["Year"] := Y
	mDO["Month"] := M
	
	mDO["PriorMonth"] := mDO.Month > 1 ? mDO.Month - 1 : 12
	mDO["PriorYear"] := mDO.Month > 1 ? mDO.Year : mDO.Year - 1
	
	mDO["NextMonth"] := mDO.Month < 12 ? mDO.Month + 1 : 1
	mDO["NextYear"] := mDO.Month = 12 ? mDO.Year + 1 : mDO.Year
	
	mDO["NumofDays"] 		:= DaysInMonthYear(mDO.Month,mDO.Year)
	mDO["PriorMonthDays"] 	:= DaysInMonthYear(mDO.PriorMonth,mDO.PriorYear)
	mDO["NextMonthDays"] 	:= DaysInMonthYear(mDO.NextMonth,mDO.NextYear)
	
	mDO["Start"] := DayOfWeek(mDO.Year mDO.Month 01 000000)
}

AttachEvents()
{
	cWB.document.parentWindow.ahk_eventClicked := Func("ahk_eventClicked")
	cWB.document.parentWindow.ahk_Next := Func("Next")
	cWB.document.parentWindow.ahk_Prev := Func("Prev")
}

Display(WB,html_str) {
	Count:=0
	while % FileExist(f:=A_Temp "\" A_TickCount A_NowUTC "-tmp" Count ".DELETEME.html")
		Count+=1
	FileAppend,%html_str%,%f%
	WB.Navigate("file://" . f)
}

AddEvent(Len,Desc,Parent)
{
	static Classlens := ["w1","w2","w3","w4","w5","w6","w7"]
	
	ParentCol := SubStr(StrSplit(Parent.className," ").2,2,1) - 1

	event := cWB.document.createElement("div")
	eventA := cWB.document.createElement("a")
	eventA.setAttribute("onClick", "ahk_eventClicked(event,this)")
	eventA.innerText := Desc
	event.setAttribute("class","Event1 " Classlens[Len])
	event.appendChild(eventA)
	Parent.appendChild(event)
	clipboard := parent.innerHTML
}

PlaceHolder(pCol,Week)
{
	Container := cWB.document.getElementsByClassName("table-Row")[Week].getElementsByClassName("columnContainer")[pCol]
	eventDiv := cWB.document.createElement("div")
	eventDiv.setAttribute("class","pEvent1")
	Container.appendChild(eventDiv)
}

NewRow(Parent)
{
	ele := cWB.document.createElement("tr")
	NewRow := Parent.appendChild(ele)
	return, NewRow
}

NewCol(colspan)
{
	ele := cWB.document.createElement("td")
	ele.setAttribute("colspan",colspan)
	return, ele
}

